#include "MySd2Card.h"

const int chipSelect = 4;
bool cardOK = false;
Sd2Card MySD;
//uint8_t MyPWD[16] = { 0x86, 0xFF, 0x50, 0xDB, 0x65, 0x49, 0xD7, 0x45, 0xF4, 0x8D, 0x5F, 0x0D, 0xD2, 0x9B, 0x55, 0x10 };
uint8_t MyPWD[16] = { 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAA, 0xAB };

void setup() {
  
  Serial.begin(115200);
  while (!Serial) {
    ; // wait for serial port to connect.
  }
  uint8_t test = true;
  Serial.print("True is: ");
  Serial.println(test,HEX);
  test = false;
  Serial.print("False is: ");
  Serial.println(test,HEX);
#ifdef USE_SPI_LIB
  Serial.println("USE_SPI_LIB");
#else
  Serial.println("USE_SOFT_SPI");
#endif

  //for ( uint8_t i = 0; i<16; i++ ) Serial.println( MyPWD[i], HEX );
  
  Serial.println("Initializing SD card…");
  pinMode(10, OUTPUT);
  
  //init SD card
  uint8_t initResult = MySD.init(SPI_HALF_SPEED, chipSelect);
    Serial.print("Init Result: ");
  Serial.println(initResult,HEX);
  if ( initResult ) {
    
    Serial.println("card initialized.");
    cardOK = true;
  } else {
    Serial.println("Card failed, or not present");
    Serial.print("Error Code: ");
    Serial.println(MySD.errorCode(),HEX);
    Serial.print("Status: ");
    Serial.println(MySD.errorData(),BIN);
  }

  if ( cardOK ) {
    Serial.print("CID: ");
    cid_t CID;
    uint8_t res = MySD.readCID(&CID);
    Serial.println(CID.psn,HEX);
  }

  if ( MySD.errorCode() == 0x18 ) {
    Serial.println("Card is locked!");
    Serial.println("Unlocking...");
    if ( MySD.unlockCard(&MyPWD[0]) ) {
//    if ( MySD.eraseCard() ) {
      Serial.println("Done.");    
    } else {
      Serial.println("Unlock Failed.");
      Serial.print("Error Code: ");
      Serial.println(MySD.errorCode(),HEX);
      Serial.print("Status: ");
      Serial.println(MySD.errorData(),BIN);
      for (uint8_t n = 5; n; n--) {
//        MySD.unlockCard(&MyPWD[0]);
      }
    }
  }


}

void loop() {

  if ( cardOK ) {
     ; // now do nothing...
  }

}

